﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace Uloha
{
    public partial class Form1 : Form
    {
        string[] cmdparams;
        string ImageFileName = "";
        string currentPath = "";

        List<string> filesInPath;
        int curr_pos = 0;

        // Současný obrázek
        Image currentImage;
        int imageWidth, imageHeight;
        long fileSize;
        DateTime creationDate;
        DisplayMode mod;

        // Mód zobrazení
        public enum DisplayMode
        {
            FileBrowse,
            ImageDisplay
        }
       

        public Form1()
        {
            InitializeComponent();
        }

        // Zkontroluje parametry příkazové řádky
        private void Form1_Load(object sender, EventArgs e)
        {
            this.panelBrowse.BringToFront();
            cmdparams = Environment.GetCommandLineArgs();
            string param = "";
            for (int i = 1; i < cmdparams.Length; i++)
            { param += " " + cmdparams[i]; }
           
            if (param == "") 
                { UpdateBrowseListView(Environment.CurrentDirectory); ChangeModeToFileBrowse(); }
    else {
        param = param.Substring(1);
            if (System.IO.Directory.Exists(param))
                {
                  this.driveListBox1.Drive = System.IO.Path.GetPathRoot(param);
                  this.dirListBox1.Path = param;
                  UpdateBrowseListView(param);
                 
                  ChangeModeToFileBrowse();
               
                }
            else if (System.IO.File.Exists(param))
                {
                  UpdateBrowseListView(Path.GetDirectoryName(param));
                  this.driveListBox1.Drive = System.IO.Path.GetPathRoot(param);
                  this.dirListBox1.Path = Path.GetDirectoryName(param);
                  
                  DisplayTheImage(param);
                }
            }



        }

        // Otevře obrázek podle dialogu a načte jeho adresář
        private void otevřítObrázekToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                currentPath = System.IO.Path.GetDirectoryName(this.openFileDialog1.FileName);
                this.driveListBox1.Drive = System.IO.Path.GetPathRoot(currentPath);
                this.dirListBox1.Path = currentPath;
                UpdateBrowseListView(currentPath);
                DisplayTheImage(this.openFileDialog1.FileName);
               
               
            

            }
        }

        // Zobrazí obrázek na celou obrazovku
        private void DisplayTheImage(string imagepath)
        {
            curr_pos = filesInPath.IndexOf(imagepath);
            LoadTheImage(imagepath);
            ChangeModeToImage();
            this.pictureBox.Image = currentImage;
        }

       
        public void DisplayImageByNumber(int number)
        {
            DisplayTheImage(filesInPath[number]);

        }

        private void pictureBox_Click(object sender, EventArgs e)
        {
            ChangeModeToFileBrowse();
        }

        // Klávesové zkratky
        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {
            switch (e.KeyCode)
            {
                case Keys.S:
                    ChangeModeToImage();
                    InitiateSlideShow();
                    break;
                case Keys.E:
                    this.exportovatDoHTMLToolStripMenuItem_Click(sender, EventArgs.Empty);
                    break;
                case Keys.Escape:
                    if (this.timerSlide.Enabled == true)
                    { this.timerSlide.Enabled = false; }
                    else
                    { this.Close(); }
                    break;
               
            }
            if (mod == DisplayMode.ImageDisplay)
            {
                switch (e.KeyCode)
                {
                   
                    case Keys.Multiply:

                        this.pictureBox.Dock = DockStyle.None;
                        this.pictureBox.Left = 0;
                        this.pictureBox.Top = 0;
                        this.pictureBox.Width = 1;
                        this.pictureBox.Height = 1;
                        this.pictureBox.SizeMode = PictureBoxSizeMode.AutoSize;
                      
                        break;
                    case Keys.Divide:
                        this.pictureBox.SizeMode = PictureBoxSizeMode.Zoom;
                        this.pictureBox.Dock = DockStyle.Fill;
                        break;
                    case Keys.Enter:
                        ChangeModeToFileBrowse();
                        break;
                    case Keys.G:
                        this.zobrazitČernobíleToolStripMenuItem_Click(sender, EventArgs.Empty);
                        break;
                   
                    case Keys.R:
                        this.otočitO90StupňůDopravaToolStripMenuItem_Click(sender, EventArgs.Empty);
                        break;
                    case Keys.L:
                        this.otočitO90StupňůDolevaToolStripMenuItem_Click(sender, EventArgs.Empty);
                        break;
                    case Keys.V:
                        this.vertikálněPřeklopitToolStripMenuItem_Click(sender, EventArgs.Empty);
                        break;
                    case Keys.H:
                        this.horizontálněPřeklopitToolStripMenuItem_Click(sender, EventArgs.Empty);
                        break;
                    case Keys.Home:
                        this.prvníObrázekVeSložceToolStripMenuItem_Click(sender, EventArgs.Empty);
                        break;
                    case Keys.End:
                        this.posledníObrázekVeSložceToolStripMenuItem_Click(sender, EventArgs.Empty);
                        break;
                    case Keys.PageUp:
                        this.předchozíObrázekToolStripMenuItem_Click(sender, EventArgs.Empty);
                        break;
                    case Keys.PageDown:
                        this.následujícíObrázekToolStripMenuItem_Click(sender, EventArgs.Empty);
                        break;

                }


            }
        }

        // Funkce rotací
        private void otočitO90StupňůDopravaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            currentImage.RotateFlip(RotateFlipType.Rotate90FlipNone);
            this.pictureBox.Image = currentImage;
        }

        private void otočitO90StupňůDolevaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            currentImage.RotateFlip(RotateFlipType.Rotate270FlipNone);
            this.pictureBox.Image = currentImage;
        }

        private void vertikálněPřeklopitToolStripMenuItem_Click(object sender, EventArgs e)
        {
           

            currentImage.RotateFlip(RotateFlipType.RotateNoneFlipY);
            this.pictureBox.Image = currentImage;
        }

        private void horizontálněPřeklopitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            currentImage.RotateFlip(RotateFlipType.RotateNoneFlipX);
            this.pictureBox.Image = currentImage;
        }



        private void zobrazitMódObrázkuToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ChangeModeToImage();
        }

        private void zobrazitMódProhlížečeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ChangeModeToFileBrowse();
        }

        // Operace se stromovým seznamem

        private void driveListBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                this.dirListBox1.Path = this.driveListBox1.Drive;
            }
            catch
            {
            }
        }


        private void dirListBox1_Click(object sender, EventArgs e)
        {
            this.infoLabel.Text = this.dirListBox1.Path;
            UpdateBrowseListView(this.dirListBox1.Path);          
        }

        // Aktualizuje seznam obrázků v prohlížeči
        public void UpdateBrowseListView(string pth)
        {
            string[] files = System.IO.Directory.GetFiles(pth, "*.jpg", SearchOption.TopDirectoryOnly);
            string[] files2 = System.IO.Directory.GetFiles(pth, "*.jpeg", SearchOption.TopDirectoryOnly);
            filesInPath = new List<string>(files);
            filesInPath.AddRange(files2);
            filesInPath.Sort();

            this.listView.Clear();
            foreach (string onefile in filesInPath)
            {
                this.listView.Items.Add(System.IO.Path.GetFileName(onefile));

            }

            currentPath = pth;
            Valid = new bool[filesInPath.Count];
            Preloaded = new StoredImage[filesInPath.Count];

        }

        // Otevře složku pomocí standartního dialogu Windows
        private void otevřítSložkuToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.folderBrowserDialog1.ShowDialog() == DialogResult.OK)
            {
                this.driveListBox1.Drive = System.IO.Path.GetPathRoot(this.folderBrowserDialog1.SelectedPath);
                this.dirListBox1.Path = this.folderBrowserDialog1.SelectedPath;
               
                UpdateBrowseListView(this.folderBrowserDialog1.SelectedPath);
              



            }
        }

        private void listView_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (this.listView.SelectedItems.Count == 1)
            {
                PrepareAnImage(currentPath + "\\" + this.listView.SelectedItems[0].Text, true);
            }
        }

        private void listView_Click(object sender, EventArgs e)
        {
            if (this.listView.SelectedItems.Count == 1)
            {
                DisplayTheImage(currentPath + "\\" + this.listView.SelectedItems[0].Text);
            }
        }

        private void prvníObrázekVeSložceToolStripMenuItem_Click(object sender, EventArgs e)
        {
            DisplayImageByNumber(0);
        }

        private void posledníObrázekVeSložceToolStripMenuItem_Click(object sender, EventArgs e)
        {
            DisplayImageByNumber(filesInPath.Count - 1);
        }

        private void předchozíObrázekToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (curr_pos == 0) { curr_pos = filesInPath.Count; }
            DisplayImageByNumber(curr_pos - 1);
        }

        private void následujícíObrázekToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (curr_pos == filesInPath.Count - 1) { curr_pos = -1; }
            DisplayImageByNumber(curr_pos + 1);
        }
        public void ChangeModeToFileBrowse()
        {
            mod = DisplayMode.FileBrowse;
            this.obrázekToolStripMenuItem.Enabled = false;
            this.zobrazitToolStripMenuItem.Enabled = false;
            this.panelBrowse.BringToFront();

        }
        public void ChangeModeToImage()
        {
            mod = DisplayMode.ImageDisplay;

            this.obrázekToolStripMenuItem.Enabled = true;
            this.zobrazitToolStripMenuItem.Enabled = true;
            this.panelImage.BringToFront();
        }

        private void ukončitProhlížečObrázkůToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        // Promění obrázek na černobílý odraz
        private void zobrazitČernobíleToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string tmpLabelText = this.infoLabel.Text;
            this.infoLabel.Text = "Prosím čekejte... tato operace může chvíli trvat.";
            this.Invalidate();
            this.Update();
            Bitmap tempBmp = new Bitmap(currentImage);
            tempBmp = ConvertToWhiteBlack(tempBmp);
            currentImage = tempBmp as Image;
            this.pictureBox.Image = currentImage;
            this.infoLabel.Text = tmpLabelText;
        }

        private void prezentaceToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ChangeModeToImage();
            InitiateSlideShow();
        }

        private void timerSlide_Tick(object sender, EventArgs e)
        {
            if (curr_pos == filesInPath.Count - 1)
            { DisplayImageByNumber(0); }
            else { DisplayImageByNumber(curr_pos + 1); }
        }


        // Vytvoří HTML soubor jako galerii
        private void exportovatDoHTMLToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.folderBrowserDialog1.ShowDialog() == DialogResult.OK)
            {
                string targetpath = this.folderBrowserDialog1.SelectedPath;
                string HTML = "<div align='center'><h2>Galerie</h2>";
                  
                foreach (string f in filesInPath)
                {
                    File.Copy(f, targetpath + "\\" + Path.GetFileName(f));
                    HTML += "<a href='" + targetpath + "\\" + Path.GetFileName(f) + "'><img src='" + targetpath + "\\" + Path.GetFileName(f) + "' width='320px' height='240px'></a>";



                }
                HTML += "</div>";
                File.WriteAllText(targetpath + "\\index.html", HTML);
                MessageBox.Show("HTML galerie vygenerována.");




            }
        }

        private void nápovědaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Napoveda n = new Napoveda();
            n.Show();
        }

        private void listView_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                this.listView_Click(sender, EventArgs.Empty);

            }
        }




    }
}
