﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace Uloha
{
    // Třída k ukládání přednačtených obrazů
    public class StoredImage
    {
        public String Filename;
        public Image Image;
        public DateTime created;
        public long Filesize;
       

    }
    public partial class Form1 : Form
    {
        // Pole Preloaded slouží k ukládání předpřipravených obrázků
        bool[] Valid;
        StoredImage[] Preloaded;





        // Podprogram pro převod na odstíny šedi
        public Bitmap ConvertToWhiteBlack(Bitmap source)
        {
            Bitmap localBitmap = new Bitmap(source.Width,source.Height);
            for(int y=0;y<localBitmap.Height;y++)
                {
                  for(int x=0;x<localBitmap.Width;x++)
                  {
                     Color c=source.GetPixel(x,y);
                     int luma = (int)(c.R*0.3 + c.G*0.59+ c.B*0.11);
                     localBitmap.SetPixel(x,y,Color.FromArgb(luma,luma,luma));
                  }

                }

            return localBitmap;

        }

        // Načte obrázek, přednačte následující a předchozí, zobrazí info k obrázku
        public void LoadTheImage(String lfilename)
        {
            ImageFileName = lfilename;
            if ((Valid != null) && (Valid.Length > curr_pos) && Valid[curr_pos])
            {
                currentImage = Preloaded[curr_pos].Image;

            }
            else
            {
               currentImage = Image.FromFile(ImageFileName);
            }
            if ((!(curr_pos == filesInPath.Count - 1)) && (!(Valid[curr_pos + 1])))
            {
                Preloaded[curr_pos + 1] = PrepareAnImage(filesInPath[curr_pos + 1], false);
                Valid[curr_pos + 1] = true;
            }
            if ((!(curr_pos == 0)) && (!(Valid[curr_pos - 1])))
            {
                Preloaded[curr_pos - 1] = PrepareAnImage(filesInPath[curr_pos - 1], false);
                Valid[curr_pos - 1] = true;
            }



            imageHeight = currentImage.Height;
            imageWidth = currentImage.Width;
            creationDate = System.IO.File.GetCreationTime(ImageFileName);
            System.IO.FileInfo f = new System.IO.FileInfo(ImageFileName);
            fileSize = f.Length;
            this.infoLabel.Text = ImageFileName + " (" + fileSize + " B, " + creationDate.ToString() + ", " + imageWidth.ToString() + "x" + imageHeight.ToString() + ", 100%, obrázek " + (1 + curr_pos).ToString() + "/" + filesInPath.Count + ")";
        }

        // Připraví obrázek pro přednačtení
        // Také se používá pro zobrazování informací o obrázku v módu prohlížení složky
        public StoredImage PrepareAnImage(String lfilename, bool DisplayInStatusBar)
        {
            StoredImage stor;
            stor = new StoredImage();
            stor.Filename = lfilename;
            stor.Image = Image.FromFile(lfilename);
           
            stor.created = System.IO.File.GetCreationTime(lfilename);
            System.IO.FileInfo lf = new System.IO.FileInfo(lfilename);
            stor.Filesize = lf.Length;

            if (DisplayInStatusBar)
            {
                this.labelFileName.Text = lfilename;
                this.labelFileInfo.Text = "(" + stor.Filesize + " B, " + stor.Image.Width + "x" + stor.Image.Height + ", " + stor.created.ToString() + ")";

            }

            return stor;

        }

        // Spustí prezentaci
        public void InitiateSlideShow()
        {
            this.timerSlide.Enabled = true;

        }
    }
}
